%  
%  vdpfev201801.m 
%       origine : pp07 (2011)
%  oscillateur de Van der Pol, rk4  
%  integration de  dx/dt =  y + x - x**3 , dy/dt =  -x
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%

x = .05 ; 
y = .05 ;  
dt = .1
nn = 200     
  %%%%%%  x = 1.2 , y = 1. 

xx = zeros (nn,1) ; yy = xx ; 

x1 = x + .5*dt * (y+x-x**3) ; 
y1 = y + .5*dt * (-x) ; 
x2 = x + .5*dt * (y1+x1-x1**3) ; 
y2 = y + .5*dt * (-x1) ; 
x3 = x + dt * (y2+x2-x2**3) ; 
y3 = y + dt * (-x2) ; 
x4 = x + (dt/6) * ( (y+x-x**3) + 2*(y1+x1-x1**3) + 2*(y2+x2-x2**3) + (y3+x3-x3**3) ) ; 
y4 = y + (dt/6) * ( -x -2*x1 -2*x2 -x3 ) ;   
xx(1) = x ; yy(1) = y ; 

for j = 1:nn-1
x1 = x + .5*dt * (y+x-x**3) ; 
y1 = y + .5*dt * (-x) ; 
x2 = x + .5*dt * (y1+x1-x1**3) ; 
y2 = y + .5*dt * (-x1) ; 
x3 = x + dt * (y2+x2-x2**3) ; 
y3 = y + dt * (-x2) ; 
x4 = x + (dt/6) * ( (y+x-x**3) + 2*(y1+x1-x1**3) + 2*(y2+x2-x2**3) + (y3+x3-x3**3) ) ; 
y4 = y + (dt/6) * ( -x -2*x1 -2*x2 -x3 ) ;   

x = x4 ; y = y4 ; 
xx(j+1) = x ; yy(j+1) = y ; 
end 
x , y 


%  sauvegarde sur fichier 
filename = "vanderpol-27fevrier2018";
 fid = fopen (filename, "w");
 fprintf(fid, "#  Van der Pol   fd   27 fevrier 2018 \n" );
 fprintf(fid, "#    \n" );
 fprintf(fid, "#  x          y        \n" );

for j = 1:nn   
fprintf (fid, "%9f %9f \n",  xx(j) , yy(j) )   ;
end 

 fclose (fid) ;
