%  
%  vdpfev201802.m 
%       origine : vdpfev201801.m  
%  oscillateur de Van der Pol, rk4  
%  integration de  dx/dt =  y + x - x**3 , dy/dt =  -x
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%

nbp = 7 

dt = .1
nn = 200     
  %%%%%%  x = 1.2 , y = 1. 



xx = zeros (nn,nbp) ; yy = xx ; 

%%% boucle sur les diverses conditions initiales 

for k = 1 : nbp 
	  if (k==1) x = 0   ; y = -.8 ; end 
	  if (k==2) x = .05 ; y = .05 ; end 
	  if (k==3) x = -2 ; y = -1 ; end 
	  if (k==4) x = 0  ; y = -2 ; end 
	  if (k==5) x = 2  ; y = 0  ; end 
	  if (k==6) x = .5  ; y = .5  ; end 
	  if (k==7) x = -2  ; y = 2  ; end 


x1 = x + .5*dt * (y+x-x**3) ; 
y1 = y + .5*dt * (-x) ; 
x2 = x + .5*dt * (y1+x1-x1**3) ; 
y2 = y + .5*dt * (-x1) ; 
x3 = x + dt * (y2+x2-x2**3) ; 
y3 = y + dt * (-x2) ; 
x4 = x + (dt/6) * ( (y+x-x**3) + 2*(y1+x1-x1**3) + 2*(y2+x2-x2**3) + (y3+x3-x3**3) ) ; 
y4 = y + (dt/6) * ( -x -2*x1 -2*x2 -x3 ) ;   
xx(1,k) = x ; yy(1,k) = y ; 

for j = 1:nn-1
x1 = x + .5*dt * (y+x-x**3) ; 
y1 = y + .5*dt * (-x) ; 
x2 = x + .5*dt * (y1+x1-x1**3) ; 
y2 = y + .5*dt * (-x1) ; 
x3 = x + dt * (y2+x2-x2**3) ; 
y3 = y + dt * (-x2) ; 
x4 = x + (dt/6) * ( (y+x-x**3) + 2*(y1+x1-x1**3) + 2*(y2+x2-x2**3) + (y3+x3-x3**3) ) ; 
y4 = y + (dt/6) * ( -x -2*x1 -2*x2 -x3 ) ;   

x = x4 ; y = y4 ; 
xx(j+1,k) = x ; yy(j+1,k) = y ; 
end 
x , y 

end   %%%  fin boucle sur les conditions initiales 


%  sauvegarde sur fichier 
filename = "vanderpol-27fevrier2018";
 fid = fopen (filename, "w");
 fprintf(fid, "#  Van der Pol   fd   27 fevrier 2018 \n" );
 fprintf(fid, "#    \n" );
 fprintf(fid, "#  x          y        \n" );

for j = 1:nn   
for k = 1 : nbp 
	  fprintf (fid, "%9f %9f ",  xx(j,k) , yy(j,k) ) ; end 
	  fprintf (fid, "\n ") 
  end 
 fclose (fid) ;
