% cn.m
% schema de Crank Nicolson  pour Van de Pol  
% fd, 16 janvier 2005 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  entrees         x dans R^t2
%                  dt pas de temps
%  sortie     y solution de y - dt*f(y)/2  = x + dt*f(x)/2
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  function y=cn(x,dt);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% matrice identite
  Id=zeros(2,2) ; Id(1,1)=1 ; Id(2,2)=1 ; 
% initialisation : schema explicite
  y=x+dt*f(x) ; xp=x + dt*f(x)/2 ; 
% boucle de Newton
for i=1:10;
  A = fp(y) ; res= xp  - y + 0.5*dt*f(y) ; 
  dy=((Id-0.5*dt*A)**(-1))*res ; 
y=y+dy ;
end ; 
